import { EventEmitter, AfterViewInit, OnChanges, ElementRef, Renderer } from '@angular/core';
/**
 * A simple round analog clock based on SVG and JavaScript for animation.
 */
export declare class AcAnalogClock implements AfterViewInit, OnChanges {
    private rd;
    private document;
    /**
     * The background color of the clock's body.
     */
    bgColor: string;
    /**
     * The color of the second arrow.
     */
    secondColor: string;
    /**
     * The color of the minute arrow.
     */
    minuteColor: string;
    /**
     * The color of the hour arrow.
     */
    hourColor: string;
    /**
     * The diameter of tje clock in pixels.
     */
    diameter: number;
    /**
     * Whether to show seconds or not. This does not affect the timer.
     */
    showSeconds: boolean;
    /**
     * An event fired every minute.
     */
    minuteClock: EventEmitter<Date>;
    /**
     * An event fired every hour.
     */
    hourClock: EventEmitter<Date>;
    hourhandTransform: ElementRef;
    minutehandTransform: ElementRef;
    secondhandTransform: ElementRef;
    svg: ElementRef;
    constructor(rd: Renderer, document: HTMLDocument);
    ngOnChanges(changes: any): void;
    ngAfterViewInit(): void;
    setRotate(element: ElementRef, value: string): void;
    private makeMarks();
}
