import { AcDataGridHeader } from './ac-datagridheader';
import { AcDataGridItem } from './ac-datagriditem';
export declare enum Direction {
    Ascending = 0,
    Descending = 1,
}
/**
 * The controlling class for Grid applications.
 *
 * This class takes an array of elements and handles:
 * - visible headers, managed by @Hidden() decorator
 * - create header titles, managed by @Display() decorator
 * - sorting
 * - filtering
 * - count total rows
 * - paging
 */
export declare class AcDataGridModel<T> {
    searchValue: T;
    currentPageIndex: number;
    pageSize: number;
    private _items;
    constructor(items: T[], typeInstance: any, pageSize?: number);
    readonly totalRows: number;
    readonly totalFilteredRows: number;
    private readonly currentRowStart;
    private readonly currentRowEnd;
    readonly startRow: number;
    readonly maxPageIndex: number;
    items: T[];
    getItemSorted(sortColumn: string, sortDirection: Direction): T[];
    readonly itemsFiltered: T[];
    readonly itemsOnCurrentPage: T[];
    columnsOfItemValues(item: T): Array<any>;
    columnsOfItem(item: T): Array<AcDataGridItem>;
    sortColumn(colName: string, dir: string): void;
    private _headers;
    readonly headers: Array<AcDataGridHeader>;
    readonly headersNotVisible: Array<AcDataGridHeader>;
    removeColumn(colname: string): void;
    addColumn(colname: string): void;
    private createHeadersForType(type);
}
