var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injector, Pipe } from '@angular/core';
/**
 * This pipe allows the dynamic formatting of data in forms or grid by applying
 * the @Format(PipeName) decorator.
 *
 * Usage within the form:
 *
 * @example {{ data | formatData:model }}
 *
 * If the model has a decorator for the specific property 'data' refers to, it will pull
 * the actual Pipe from there:
 *
 * @example @Format(PercentagePipe)
 *          percent: number = 0;
 *
 * The module must have access to <code>PercentPipe</code> and the dynamic pipe must have
 * access to a model that's a real instance (interfaces will not work). This is because
 * we need to reflect the meta data from hidden properties that exists for sure.
 *
 */
var AcFormatDataPipe = (function () {
    function AcFormatDataPipe(injector) {
        this.injector = injector;
    }
    AcFormatDataPipe.prototype.transform = function (value, pipeToken, pipeArgs) {
        if (!pipeToken) {
            return value;
        }
        else {
            if (pipeArgs && pipeArgs.length >= 2) {
                // First arg is the model
                var model = pipeArgs[0];
                var pipe = this.injector.get(pipeToken);
                return pipe.transform.apply(pipe, [value].concat(pipeArgs));
            }
            else {
                console.log('Illegal usage of "formatData" Pipe. Use two parameters like this: {{ data | formatData:model:propNames }}');
                return value;
            }
        }
    };
    return AcFormatDataPipe;
}());
AcFormatDataPipe = __decorate([
    Pipe({
        name: 'formatData'
    }),
    __metadata("design:paramtypes", [Injector])
], AcFormatDataPipe);
export { AcFormatDataPipe };

//# sourceMappingURL=ac-formatdata.pipe.js.map
