var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input } from '@angular/core';
import { FormGroup } from '@angular/forms';
/**
 * This component creates a complete editor out of a viewmodel.
 * It creates one field for each property not decorated with @Hidden.
 *
 */
var AcAutoForm = (function () {
    function AcAutoForm() {
        /**
         * Ungrouped element will appear at the end, after all groupes.
         * If there are no groups this will be ignored. Optional.
         */
        this.ungroupedAfter = true;
        this.editors = new Array();
        this.groups = new Array();
    }
    AcAutoForm.prototype.ngOnInit = function () {
        // take all controls as is
        var hasDecorators = (this.formGroup['__editorModel__']);
        var _loop_1 = function () {
            var displayOrder = 0;
            var groupOrder = 0;
            var groupName;
            var groupDesc = void 0;
            var isInGroup = false;
            if (hasDecorators) {
                displayOrder = this_1.formGroup['__editorModel__']["__displayOrder__" + controlName];
                isInGroup = !!this_1.formGroup['__editorModel__']["__isGrouped__" + controlName];
                if (isInGroup) {
                    groupName = this_1.formGroup['__editorModel__']["__groupName__" + controlName];
                    groupOrder = this_1.formGroup['__editorModel__']["__groupOrder__" + controlName];
                    groupDesc = this_1.formGroup['__editorModel__']["__groupDesc__" + controlName];
                }
            }
            if (!isInGroup) {
                // if not part of any group just push to main group
                this_1.editors.push({
                    key: displayOrder,
                    editor: controlName
                });
            }
            else {
                // check if group already exists
                var existingGroupArray = this_1.groups.filter(function (g) { return g.name === groupName; });
                groupExists = existingGroupArray.length === 1;
                if (!groupExists) {
                    this_1.groups.push({
                        key: groupOrder,
                        name: groupName,
                        desc: groupDesc,
                        editors: new Array()
                    });
                }
                // add field to existing group (assume that here the group always exists)
                var existingGroup = this_1.groups.filter(function (g) { return g.name === groupName; })[0];
                // and store
                existingGroup.editors.push({
                    key: displayOrder,
                    editor: controlName
                });
            }
        };
        var this_1 = this, groupExists;
        // loop through all fields
        for (var controlName in this.formGroup.controls) {
            _loop_1();
        }
        // check the display decorator and sort
        this.editors.sort(function (e, n) { return e.key - n.key; });
        // sort groups
        this.groups.sort(function (e, n) { return e.key - n.key; });
    };
    AcAutoForm.prototype.grouped = function () {
        return this.groups && this.groups.length > 0;
    };
    return AcAutoForm;
}());
__decorate([
    Input(),
    __metadata("design:type", FormGroup)
], AcAutoForm.prototype, "formGroup", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], AcAutoForm.prototype, "ungroupedAfter", void 0);
AcAutoForm = __decorate([
    Component({
        selector: 'ac-autoform',
        styles: [
            'fieldset { border-top: 1px silver solid; padding: 10px; }',
            'legend { width: auto; padding-left: 10px; padding-right: 10px; font-size: 1em;}'
        ],
        template: "<ng-content></ng-content><ng-container *ngIf=\"!ungroupedAfter\"><ac-editor *ngFor=\"let editor of editors\" [name]=\"editor.editor\" [userForm]=\"formGroup\"></ac-editor></ng-container><ng-container *ngIf=\"grouped()\"><fieldset *ngFor=\"let group of groups\"><legend [attr.title]=\"group.desc\" *ngIf=\"group.name\">{{ group.name }}</legend><ac-editor *ngFor=\"let editor of group.editors\" [name]=\"editor.editor\" [userForm]=\"formGroup\"></ac-editor></fieldset></ng-container><ng-container *ngIf=\"ungroupedAfter\"><ac-editor *ngFor=\"let editor of editors\" [name]=\"editor.editor\" [userForm]=\"formGroup\"></ac-editor></ng-container>"
    }),
    __metadata("design:paramtypes", [])
], AcAutoForm);
export { AcAutoForm };

//# sourceMappingURL=ac-autoform.component.js.map
