import { OnInit } from '@angular/core';
import { AcInfoBoxOptions } from './models/options-infobox';
import { Meaning } from '../../../core/utils/enum-colors';
/**
 * The InfoBox is a rectangle area to show dynamic data. It has icon, text, and additional information.
 *
 * @param icon The name of an FontAwesome icon, such as "fa-circle"
 * @param text The text that appears prominently
 * @param number A number that covers the element as the value
 * @param footerText A smaller explanation text at the end
 * @param footerLink A link, suitable for [routerLink] that is being invoked from the footerText
 * @param progressValue A progress Value that creates a progress bar position
 * @param progressText A progress Text that replaces the footerText
 * @param color The background color
 */
export declare class AcInfoBox implements OnInit {
    icon: string;
    text: string;
    number: string;
    footerText: string;
    footerLink: string;
    progressValue: number;
    progressText: string;
    color?: Meaning;
    options: AcInfoBoxOptions;
    constructor();
    ngOnInit(): void;
    getColor(type: string): string;
}
