import { EventEmitter } from '@angular/core';
import { AcTreeNode } from './models/index';
/**
 * A treeview that can handle @see AcTreeNode objects that create text, checkboxes, or highlights.
 * A node can have an icon. The icons are based on FontAwesome's css classes.
 */
export declare class AcTreeView {
    nodes: AcTreeNode;
    nodeClick: EventEmitter<AcTreeNode>;
    checkChanged: EventEmitter<AcTreeNode>;
    selectedChanged: EventEmitter<AcTreeNode>;
    collapseChanged: EventEmitter<AcTreeNode>;
    constructor();
    onNodeClick(node: AcTreeNode): void;
    onCheckChanged(node: AcTreeNode): void;
    onSelectedChanged(node: AcTreeNode): void;
    onCollapseChanged(node: AcTreeNode): void;
    ngOnChanges(): void;
}
