var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
import { AcTreeNode } from './models/index';
/**
 * A treeview that can handle @see AcTreeNode objects that create text, checkboxes, or highlights.
 * A node can have an icon. The icons are based on FontAwesome's css classes.
 */
var AcTreeView = (function () {
    function AcTreeView() {
        this.nodeClick = new EventEmitter();
        this.checkChanged = new EventEmitter();
        this.selectedChanged = new EventEmitter();
        this.collapseChanged = new EventEmitter();
    }
    AcTreeView.prototype.onNodeClick = function (node) {
        this.nodeClick.emit(node);
    };
    AcTreeView.prototype.onCheckChanged = function (node) {
        this.checkChanged.emit(node);
    };
    AcTreeView.prototype.onSelectedChanged = function (node) {
        this.selectedChanged.emit(node);
    };
    AcTreeView.prototype.onCollapseChanged = function (node) {
        this.collapseChanged.emit(node);
    };
    AcTreeView.prototype.ngOnChanges = function () {
        return;
    };
    return AcTreeView;
}());
__decorate([
    Input(),
    __metadata("design:type", AcTreeNode)
], AcTreeView.prototype, "nodes", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], AcTreeView.prototype, "nodeClick", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], AcTreeView.prototype, "checkChanged", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], AcTreeView.prototype, "selectedChanged", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], AcTreeView.prototype, "collapseChanged", void 0);
AcTreeView = __decorate([
    Component({
        selector: 'ac-tree',
        template: "<ul class=\"treeview\"><ac-treenode [node]=\"nodes\" (nodeClick)=\"onNodeClick($event)\" (checkChanged)=\"onCheckChanged($event)\" (selectedChanged)=\"onSelectedChanged($event)\" (collapseChanged)=\"onCollapseChanged($event)\"></ac-treenode></ul>",
        styles: ['.treeview { list-style: none; margin-left: -25px; }']
    }) //
    ,
    __metadata("design:paramtypes", [])
], AcTreeView);
export { AcTreeView };

//# sourceMappingURL=ac-treeview.component.js.map
