import { EventEmitter } from '@angular/core';
import * as tree from './ac-treenodeoptions';
import { AcTreeNodeBase } from './ac-treenodebase';
/**
 * The base class.
 */
export declare class AcTreeNode implements AcTreeNodeBase {
    /**
     * Control appearance
     */
    options: tree.AcTreeNodeOptions;
    /**
     * structure
     */
    parent: AcTreeNode;
    /**
     * Subsequent nodes.
     */
    children: AcTreeNode[];
    /**
     * An identifier.
     */
    name: string;
    /**
     * Field id
     */
    id: number;
    /**
     * behavior
     */
    stateChange: EventEmitter<tree.AcTreeNodeState>;
    private _state;
    constructor(options?: tree.AcTreeNodeOptions, nodes?: AcTreeNode | AcTreeNode[]);
    readonly path: Array<AcTreeNode>;
    hasDirectAncestor(node: AcTreeNodeBase): boolean;
    readonly hasChildren: boolean;
    add(nodes: AcTreeNode | AcTreeNode[]): void;
    remove(node: AcTreeNode): boolean;
    state: tree.AcTreeNodeState;
    readonly stateIsExpandend: boolean;
    readonly stateIsDisabled: boolean;
    readonly stateIsSelected: boolean;
    readonly stateIsChecked: boolean;
}
