/**
 * The state of node
 */
export declare enum AcTreeNodeState {
    undefined = 0,
    checked = 1,
    disabled = 2,
    expanded = 4,
    selected = 8,
}
/**
 * The view options of node
*/
export declare class AcTreeNodeOptions {
    /** Show the expand icons */
    collapsable: boolean;
    /** An additional icon, must be a fontawesome class */
    icon: string;
    /** An additional icon's primary color */
    iconColor: string;
    /** An additional icon on select */
    selectedIcon: string;
    /** Text color */
    color: string;
    /** backColor */
    backColor: string;
    /** A hyperlink */
    href: string;
    /** Node can be selected */
    selectable: boolean;
    /** Node can be checked */
    checkable: boolean;
    constructor(options?: AcTreeNodeOptions);
}
